CollationAttributeFactory (Lucene 10.5.1 common API)
Description: declaration: package: org.apache.lucene.collation, class: CollationAttributeFactory

Package org.apache.lucene.collation

# Class CollationAttributeFactory

java.lang.Object
org.apache.lucene.util.AttributeFactory
org.apache.lucene.util.AttributeFactory.StaticImplementationAttributeFactory<CollatedTermAttributeImpl>
org.apache.lucene.collation.CollationAttributeFactory

public class CollationAttributeFactory extends AttributeFactory.StaticImplementationAttributeFactory<CollatedTermAttributeImpl>
Converts each token into its `CollationKey`, and then encodes the bytes as an index term.

WARNING: Make sure you use exactly the same Collator at index and query time -- CollationKeys are only comparable when produced by the same Collator. Since `RuleBasedCollator`s are not independently versioned, it is unsafe to search against stored CollationKeys unless the following are exactly the same (best practice is to store this information with the index and check that they remain the same at query time):

1. JVM vendor
2. JVM version, including patch version
3. The language (and country and variant, if specified) of the Locale used when constructing the collator via `Collator.getInstance(java.util.Locale)`.
4. The collation strength used - see `Collator.setStrength(int)`

The `ICUCollationAttributeFactory` in the analysis-icu package uses ICU4J's Collator, which makes its version available, thus allowing collation to be versioned independently from the JVM. ICUCollationAttributeFactory is also significantly faster and generates significantly shorter keys than CollationAttributeFactory. See http://site.icu-project.org/charts/collation-icu4j-sun for key generation timing and key length comparisons between ICU4J and java.text.Collator over several languages.

CollationKeys generated by java.text.Collators are not compatible with those those generated by ICU Collators. Specifically, if you use CollationAttributeFactory to generate index terms, do not use ICUCollationAttributeFactory on the query side, or vice versa.

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from class org.apache.lucene.util.AttributeFactory

  `AttributeFactory.StaticImplementationAttributeFactory<A extends AttributeImpl>`

- ## Field Summary

  ### Fields inherited from class org.apache.lucene.util.AttributeFactory

  `DEFAULT_ATTRIBUTE_FACTORY`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `CollationAttributeFactory(Collator collator)`
  Create a CollationAttributeFactory, using `TokenStream.DEFAULT_TOKEN_ATTRIBUTE_FACTORY` as the factory for all other attributes.
  `CollationAttributeFactory(AttributeFactory delegate, Collator collator)`
  Create a CollationAttributeFactory, using the supplied Attribute Factory as the factory for all other attributes.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `CollatedTermAttributeImpl`
  `createInstance()`

  ### Methods inherited from class org.apache.lucene.util.AttributeFactory.StaticImplementationAttributeFactory

  `createAttributeInstance, equals, hashCode`

  ### Methods inherited from class org.apache.lucene.util.AttributeFactory

  `getStaticImplementation`

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### CollationAttributeFactory

    public CollationAttributeFactory(Collator collator)
    Create a CollationAttributeFactory, using `TokenStream.DEFAULT_TOKEN_ATTRIBUTE_FACTORY` as the factory for all other attributes.
    Parameters:
      `collator` - CollationKey generator

  - ### CollationAttributeFactory

    public CollationAttributeFactory(AttributeFactory delegate, Collator collator)
    Create a CollationAttributeFactory, using the supplied Attribute Factory as the factory for all other attributes.
    Parameters:
      `delegate` - Attribute Factory
      `collator` - CollationKey generator

- ## Method Details

  - ### createInstance

    public CollatedTermAttributeImpl createInstance()
    Specified by:
      `createInstance` in class `AttributeFactory.StaticImplementationAttributeFactory<CollatedTermAttributeImpl>`